package de.ozgcloud.apilib.vorgang.grpc;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.NullValueCheckStrategy;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.factory.Mappers;

import de.ozgcloud.apilib.vorgang.OzgCloudServiceKonto;
import de.ozgcloud.apilib.vorgang.OzgCloudUserIdMapper;
import de.ozgcloud.apilib.vorgang.OzgCloudVorgang;
import de.ozgcloud.apilib.vorgang.OzgCloudVorgangIdMapper;
import de.ozgcloud.apilib.vorgang.OzgCloudVorgangStatusMapper;
import de.ozgcloud.vorgang.vorgang.GrpcVorgangWithEingang;

@Mapper(uses = { OzgCloudEingangMapper.class, OzgCloudVorgangIdMapper.class, OzgCloudUserIdMapper.class, OzgCloudVorgangStatusMapper.class }, //
	nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
	nullValueCheckStrategy = NullValueCheckStrategy.ALWAYS)
public interface OzgCloudVorgangMapper {

	@Mapping(target = "eingangs", ignore = true)
	@Mapping(target = "vorgangNummer", source = "nummer")
	@Mapping(target = "vorgangName", source = "name")
	@Mapping(target = "header.aktenzeichen", source = "aktenzeichen")
	@Mapping(target = "header.assignedTo", source = "assignedTo")
	@Mapping(target = "header.createdAt", source = "createdAt")
	@Mapping(target = "header.status", source = "status")
	@Mapping(target = "header.serviceKonto", expression = "java(getServiceKonto(grpcVorgangWithEingang))")
	OzgCloudVorgang fromGrpc(GrpcVorgangWithEingang grpcVorgang);

	default OzgCloudServiceKonto getServiceKonto(GrpcVorgangWithEingang grpcVorgang) {
		var mapper = Mappers.getMapper(OzgCloudServiceKontoMapper.class);
		return mapper.getServiceKonto(grpcVorgang.getHeader());
	}
}
