package de.ozgcloud.apilib.vorgang.grpc;

import de.ozgcloud.apilib.vorgang.QueryTestFactory;
import de.ozgcloud.vorgang.vorgang.GrpcLogicalOperator;
import de.ozgcloud.vorgang.vorgang.GrpcQuery;
import de.ozgcloud.vorgang.vorgang.GrpcQuery.Builder;
import de.ozgcloud.vorgang.vorgang.GrpcVorgangQueryExpression;

class GrpcQueryTestFactory {

	private static final GrpcLogicalOperator LOGICAL_OPERATOR = GrpcLogicalOperator.valueOf(QueryTestFactory.LOGICAL_OPERATOR.toString());
	public static final GrpcVorgangQueryExpression EXPRESSION = GrpcVorgangQueryExpressionTestFactory.create();

	public static GrpcQuery create() {
		return createBuilder().build();
	}

	public static Builder createBuilder() {
		return GrpcQuery.newBuilder()
				.setLogicalOperator(LOGICAL_OPERATOR)
				.addExpressions(EXPRESSION);
	}
}
