package de.ozgcloud.client.autoconfigure;

import org.apache.logging.log4j.core.config.plugins.validation.constraints.NotBlank;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;
import org.springframework.validation.annotation.Validated;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import net.devh.boot.grpc.client.config.NegotiationType;

@ToString
@Getter
@Setter
@Configuration
@ConfigurationProperties("ozgcloud.user-manager")
@Validated
public class OzgCloudUserManagerProperties {
	/**
	 * Network-Address of the User-Manager instance, starting with resolving
	 * protocoll.
	 */
	@NotBlank
	private String address;
	/**
	 * Negotiation Type for the gRPC connection - possible Values: PLAINTEXT, TLS
	 */
	private NegotiationType negotiationType = NegotiationType.valueOf("TLS");
}
